#include <stdio.h>
#include <wiringPi.h>
#include <unistd.h>

volatile unsigned int *GPINP=NULL;

#define PIN 0

int main (void)
{
  volatile unsigned cc1,cc2,cc3,inp1,inp2,inp3,inp4;

  wiringPiSetup () ;
  GPINP = getGpio()+0x0204;

  pinMode (PIN, INPUT) ;

  asm volatile ("mrc p15, 0, %0, c9, c13, 0" : "=r" (cc1));
  asm volatile ("mrc p15, 0, %0, c9, c13, 0" : "=r" (cc2));
  inp1=*GPINP;
  inp2=*GPINP;
  inp3=*GPINP;
  inp4=*GPINP;
  asm volatile ("mrc p15, 0, %0, c9, c13, 0" : "=r" (cc3));
  printf("%u %u %u\n",cc1,cc2,cc2-cc1);
  printf("%u %u %u\n",cc2,cc3,cc3-cc2);
  printf("%x\n",inp1);
  printf("%x\n",inp2);
  printf("%x\n",inp3);
  printf("%x\n",inp4);
  return 0;
}
